import { PlusOutlined } from '@ant-design/icons';
import type { ActionType, ProColumns } from '@ant-design/pro-components';
import { Popconfirm } from 'antd';
import dayjs from 'dayjs';
import React, { createContext, useCallback, useRef, useState } from 'react';
import ConfigurableDrawerForm, {
  type ConfigurableDrawerFormRef,
} from '@/components/DrawerForm';
import EnhancedProTable from '@/components/EnhancedProTable';
import type { ToolbarAction } from '@/components/EnhancedProTable/types';
import { formStatusType } from '@/constants';
import {
  createTenant,
  deleteTenant,
  getTenantPage,
  type TenantPageReqVO,
  type TenantVO,
  updateTenant,
} from '@/services/system/tenant/list';
import { baseTenantColumns, formColumns } from './config';
export const waitTimePromise = async (time: number = 90) => {
  return new Promise((resolve) => {
    setTimeout(() => {
      resolve(true);
    }, time);
  });
};
const TenantList = () => {
  const configurableDrawerRef = useRef<ConfigurableDrawerFormRef>(null);
  const tableRef = useRef<ActionType>(null);
  const [type, setType] = useState<'create' | 'update'>('create');
  const [id, setId] = useState<number>(0);
  const onFetch = async (
    params: TenantPageReqVO & {
      pageSize?: number;
      current?: number;
    },
  ) => {
    await waitTimePromise();
    const data = await getTenantPage({
      ...params,
      pageNo: params.current,
      pageSize: params.pageSize,
    });
    return {
      data: data.list,
      success: true,
      total: data.total,
    };
  };

  const handleSubmit = useCallback(
    async (values: TenantVO) => {
      if (type === 'create') {
        await createTenant(values);
      } else {
        await updateTenant({
          ...values,
          id,
          expireTime: dayjs(values.expireTime).valueOf(),
        });
      }
      tableRef.current?.reload();
      return true;
    },
    [type, id],
  );

  const handleAdd = () => {
    setType('create');
    configurableDrawerRef.current?.open({});
  };
  const handleEdit = (record: TenantVO) => {
    setType('update');
    setId(record.id);

    configurableDrawerRef.current?.open(record);
  };
  const toolbarActions: ToolbarAction[] = [
    {
      key: 'add',
      label: '新建',
      type: 'primary',
      icon: <PlusOutlined />,
      onClick: handleAdd,
    },
  ];

  const actionColumns: ProColumns<TenantVO> = {
    title: '操作',
    dataIndex: 'option',
    valueType: 'option',
    fixed: 'right',
    width: 120,
    render: (_text: React.ReactNode, record: TenantVO, _: any, action: any) => [
      <a key="editable" onClick={() => handleEdit(record)}>
        编辑
      </a>,
      <Popconfirm
        title="是否删除?"
        key="delete"
        onConfirm={async () => {
          await deleteTenant(record.id);
          action?.reload();
        }}
        okText="是"
        cancelText="否"
      >
        <a>删除</a>
      </Popconfirm>,
    ],
  };
  const columns = [...baseTenantColumns, actionColumns];
  return (
    <>
      <EnhancedProTable<TenantVO>
        ref={tableRef}
        columns={columns}
        request={onFetch}
        toolbarActions={toolbarActions}
        headerTitle="租户列表"
        showIndex={false}
        showSelection={false}
      />

      <ConfigurableDrawerForm
        ref={configurableDrawerRef}
        title={formStatusType[type]}
        columns={formColumns(type)}
        onSubmit={handleSubmit}
      />
    </>
  );
};

export default TenantList;
